#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>

#define IICREADNOSUB 5
#define IICREADMSP 3
#define IICWRITE 2
#define IICREAD 1

struct iic {
	unsigned char module;
	unsigned char subaddress;
	unsigned char len;
	unsigned char *data;
};

static int i2c_fd=-1;

static void open_device(void)
{
	if (i2c_fd != -1) return;
	i2c_fd = open("/dev/i2c", O_RDWR);
	if (i2c_fd == -1) {
		perror("/dev/i2c");
		exit(1);
	}

#if 0
	iicw1(module, subaddress, v);
	printf("now set to 0x%02x\n", iicr1(module, subaddress));
	return 0;
#endif
}

static int iicRead(int module, int subaddress, unsigned char *data, int len)
{
	struct iic iic = {module, subaddress, len, data};

	open_device();
	return ioctl(i2c_fd, IICREAD, &iic);
}

static int iicWrite(int module, int subaddress, unsigned char *data, int len)
{
	struct iic iic = {module, subaddress, len, data};

	open_device();
	return ioctl(i2c_fd, IICWRITE, &iic);
}

int iicw1(int module, int subaddress, unsigned char v)
{
	return iicWrite(module, subaddress, &v, 1);
}

unsigned char iicr1(int module, int subaddress)
{
	unsigned char v;
	iicRead(module, subaddress, &v, 1);
	return v;
}
